<template>
    <BasicModal v-bind="$attrs" @register="registerModal" :title="title" @ok="handleSubmit" width="50%">
        <BasicForm @register="registerForm">
        </BasicForm>
    </BasicModal>
</template>

<script lang="ts" setup>
import { ref, unref } from 'vue';
import { FormSchema } from '/@/components/Table';
import { BasicModal, useModalInner } from '/@/components/Modal';
import { BasicForm, useForm } from '/@/components/Form/index';
import { submiSlyj } from '../api';
// Emits声明

const emit = defineEmits(['register', 'success']);

const isUpdate = ref(true);
const AdviceFormSchema: FormSchema[] = [
    { label: '污染地块ID', field: 'wrdkid', required: true, component: 'Input', show: false },
    { label: '所处阶段编码', field: 'scjdbm', required: true, component: 'Input', show: false },
    { label: 'id', field: 'id', required: true, component: 'Input', show: false },
    { label: 'pgtype', field: 'pgtype', required: true, component: 'Input', show: false },

    {
        label: '下一节点',
        field: 'nodeType',
        component: 'RadioGroup',
        required: true,
        defaultValue: 1,
        componentProps: {
            options: [
                { label: '受理', value: 1 },
                { label: '退回', value: 2 },
            ],
        },
    },
    {
        label: '办理意见',
        required: true,
        field: 'clyj',
        component: 'InputTextArea',
    },
    {
        label: '附件',
        field: 'clyjfj',
        required: true,
        component: 'JUpload',
        componentProps: {
            showUploadList: false,
        },
    },
]
//表单配置
const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
    labelWidth: 220,
    schemas: AdviceFormSchema,
    showActionButtonGroup: false,
});
//表单赋值
const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
    //重置表单
    await resetFields();
    setModalProps({ confirmLoading: false, showCancelBtn: data?.showFooter, showOkBtn: data?.showFooter });
    isUpdate.value = !!data?.isUpdate;
    if (unref(isUpdate)) {
        //表单赋值
        await setFieldsValue({
            ...data.record,
        });
    }
});
//设置标题
const title = ref('下达指导意见')
//表单提交事件
async function handleSubmit() {
    try {
        let values = await validate();
        setModalProps({ confirmLoading: true });
        //提交表单
        await submiSlyj(values);
        //关闭弹窗
        closeModal();
        emit('success');
    } finally {
        setModalProps({ confirmLoading: false });
    }
}

</script>

<style lang="less" scoped></style>